﻿<Window x:Class="SecondMonitor.TelemetryPresentation.MainWindow.MainWindow"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:viewModels="clr-namespace:SecondMonitor.Telemetry.TelemetryApplication.ViewModels;assembly=TelemetryApplication"
        xmlns:lapsSummary="clr-namespace:SecondMonitor.TelemetryPresentation.Controls.LapsSummary"
        xmlns:snapshotSection="clr-namespace:SecondMonitor.TelemetryPresentation.Controls.SnapshotSection"
        xmlns:zoomAndPan="clr-namespace:SecondMonitor.WindowsControls.WPF.ZoomAndPan;assembly=WindowsControls"
        xmlns:wpf="clr-namespace:SecondMonitor.WindowsControls.WPF;assembly=WindowsControls"
        xmlns:xctk="http://schemas.xceed.com/wpf/xaml/toolkit"
        xmlns:template="clr-namespace:SecondMonitor.TelemetryPresentation.Template"
        xmlns:popup="clr-namespace:SecondMonitor.WindowsControls.WPF.Popup;assembly=WindowsControls"
        xmlns:behaviors="clr-namespace:SecondMonitor.WindowsControls.WPF.Behaviors;assembly=WindowsControls"
        xmlns:i="http://schemas.microsoft.com/expression/2010/interactivity"
        xmlns:behavior="clr-namespace:SecondMonitor.TelemetryPresentation.Behavior"
        mc:Ignorable="d"
        Title="Telemetry Viewer" Height="450" Width="800" d:DataContext="{d:DesignInstance Type=viewModels:MainWindowViewModel}" WindowState="Maximized">
    <Window.Resources>
        <ResourceDictionary>
            <ResourceDictionary.MergedDictionaries>
                <ResourceDictionary Source="../TelemetryPresentation.xaml" />
                <ResourceDictionary Source="../Template/GraphDataTemplates.xaml" />
                <ResourceDictionary Source="../PopupWindows/PopUpTemplates.xaml" />
            </ResourceDictionary.MergedDictionaries>
            <template:GraphDataTemplateSelector x:Key="GraphDataTemplateSelector" DefaultTemplate="{StaticResource DefaultGraphDataTemplate}"
                                                WheelsGraphTemplate="{StaticResource WheelsGraphDataTemplate}" TyreTemperaturesGraphTemplate="{StaticResource TyreTemperaturesGraphDataTemplate}"
                                                ChassisGraphTemplate="{StaticResource ChassisGraphDataTemplate}"/>
        </ResourceDictionary>
    </Window.Resources>
    <Grid Background="{StaticResource Anthracite01Brush}" SnapsToDevicePixels="True">
        <Grid.ColumnDefinitions>
            <ColumnDefinition Width="2*"/>
            <ColumnDefinition Width="*"/>
        </Grid.ColumnDefinitions>
        <Grid Grid.Column="0">
            <Grid.RowDefinitions>
                <RowDefinition Height="*"/>
                <RowDefinition Height="Auto"/>
            </Grid.RowDefinitions>
            <Grid Row="0">
                <ScrollViewer CanContentScroll="False" SnapsToDevicePixels="True">
                    <ItemsControl ItemsSource="{Binding LeftPanelGraphs}" ItemTemplateSelector="{StaticResource GraphDataTemplateSelector}" SnapsToDevicePixels="True"/>
                </ScrollViewer>
            </Grid>
            <Grid Grid.Row="1" Visibility="Visible" x:Name="LapSelectorGrid">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto"/>
                    <ColumnDefinition Width="*"/>
                </Grid.ColumnDefinitions>
                <Grid Column="0" VerticalAlignment="Stretch">
                    <lapsSummary:LapSelectionControl DataContext="{Binding LapSelectionViewModel}" VerticalAlignment="Stretch" />
                </Grid>
                <Border Grid.Column="1" BorderThickness="2" BorderBrush="{StaticResource DarkGrey01Brush}" Padding="5">
                    <Grid>
                        <snapshotSection:SnapshotSectionControl DataContext="{Binding SnapshotSectionViewModel }"/>
                        <popup:PopupControl PopupWindowTemplate="{StaticResource TelemetryControlPopUp}" PopupWindowTitle="Telemetry Control" PopupContent="{Binding}" ElementToHide="{Binding ElementName=LapSelectorGrid}" Width="16" Height="16" VerticalAlignment="Top" HorizontalAlignment="Left" Margin="5"/>
                    </Grid>
                </Border>
            </Grid>
        </Grid>
        <Grid Grid.Column="1">
            <Grid.RowDefinitions>
                <RowDefinition Height="*"/>
                <RowDefinition Height="Auto"/>
            </Grid.RowDefinitions>
            <Grid Row="0">
            <ScrollViewer CanContentScroll="False">
                <ItemsControl ItemsSource="{Binding RightPanelGraphs}" ItemTemplateSelector="{StaticResource GraphDataTemplateSelector}"/>
            </ScrollViewer>
        </Grid>
        <Grid Row="1" x:Name="MapGrid">
                <Border BorderBrush="{StaticResource DarkGrey05Brush}" BorderThickness="3" CornerRadius="3">
                    <Grid ClipToBounds="True">
                        <Grid.RowDefinitions>
                            <RowDefinition Height="*"/>
                            <RowDefinition Height="Auto"/>
                        </Grid.RowDefinitions>
                        <Grid Grid.Row="0" Background="{StaticResource Anthracite05Brush}" x:Name="SelectionAnchorGrid">
                            <popup:PopupControl PopupWindowTemplate="{StaticResource MapControlPopUp}" PopupWindowTitle="Map View" PopupContent="{Binding}" ElementToHide="{Binding ElementName=MapGrid}" Width="16" Height="16" VerticalAlignment="Top" HorizontalAlignment="Left" Margin="5" Grid.ZIndex="3"/>
                            <xctk:BusyIndicator IsBusy="{Binding IsBusy}" HorizontalAlignment="Stretch" VerticalAlignment="Stretch" BusyContent="Loading Lap(s)" Grid.ZIndex="2">
                            </xctk:BusyIndicator>
                            <zoomAndPan:ZoomAndPanControl x:Name="ZoomAndPanControl" IsEnabled="{Binding IsBusy, Converter={StaticResource InvertedBooleanConverter}}" Grid.ZIndex="1" MaxContentScale="1000">
                                <ContentPresenter Margin="20,10,20,10"
                                              Content="{Binding MapViewViewModel.TrackMapViewModel}" MaxHeight="450" >
                                    <i:Interaction.Behaviors>
                                        <behaviors:RefreshBindingOnVisibilityChangeBehavior/>
                                        <behavior:MapPointsSelectionsBehavior AnchorGridName="SelectionAnchorGrid" RenderPanelName="PART_RenderCanvas"/>
                                    </i:Interaction.Behaviors>
                                </ContentPresenter>
                            </zoomAndPan:ZoomAndPanControl>
                        </Grid>
                        <Border Grid.Row="1" BorderThickness="1" BorderBrush="{StaticResource LightGrey01Brush}">
                        <StackPanel  Orientation="Horizontal" Background="{StaticResource DarkGrey01Brush}">
                                <Button Style="{StaticResource StandardButton}" Command="{Binding ResetZoomCommand, ElementName=ZoomAndPanControl, Mode=OneWay}" HorizontalAlignment="Left" MaxWidth="50" VerticalAlignment="Bottom" ToolTip="Resets the view">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button},Mode=OneWay}" Margin="5,5,5,5">
                                            <ContentPresenter Content="{StaticResource ResetIcon}"/>
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                            <CheckBox Content="Color Sectors" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}"  Margin="5,5,50,5" IsChecked="{Binding MapViewViewModel.ShowColoredSectors}"/>
                                <CheckBox Content="Show All" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}"  Margin="5,5,50,5" IsChecked="{Binding MapViewViewModel.ShowAllOverlays}"/>
                                <CheckBox Content="Throttle" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}" Margin="5" IsChecked="{Binding MapViewViewModel.ShowThrottleOverlay}"/>
                                <CheckBox Content="Brake" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}" Margin="5" IsChecked="{Binding MapViewViewModel.ShowBrakeOverlay}"/>
                                <CheckBox Content="Clutch" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}" Margin="5" IsChecked="{Binding MapViewViewModel.ShowClutchOverlay}"/>
                                <CheckBox Content="Shift Points" VerticalAlignment="Center" FontSize="{StaticResource BigFontSize}" VerticalContentAlignment="Center" Foreground="{StaticResource LightGrey01Brush}" Margin="5" IsChecked="{Binding MapViewViewModel.ShowShiftPoints}"/>

                            </StackPanel>
                        </Border>
                    </Grid>
                </Border>
            </Grid>
        </Grid>

    </Grid>
</Window>
